/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package dommanipulation;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.XMLConstants;
import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author bar
 */
public class DOMManipulation {
    private static final String DOCUMENT_NAME="data.xml";
    private static final String RESULT_NAME ="data-out.xml";
    
    private Document doc;
    
    public void loadDocument() {
        try {
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuilder = dbf.newDocumentBuilder();
            doc = docBuilder.parse(DOCUMENT_NAME);
        } catch (ParserConfigurationException | SAXException | IOException ex) {
            Logger.getLogger(DOMManipulation.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        
    }

    /**
     * Calculates and adds new element total into the element production with the total 
     * amount of products
     */
    
    public void calculateTotal() {
        int total = getTotalPrice();
        addTotalPrice(total);
        
    }
    
    /**
     * Calculates the average price of all products and adds it as a new atribute average_price 
     * to the element production
     */
    public void calculateAvg() {
        int total = getTotalPrice();
        double totalAmount = getTotalAmount();
        addAvgPrice(total/totalAmount);
    }

    public void saveDocument(){
        try {
            TransformerFactory tf = TransformerFactory.newInstance();
            Transformer transformer = tf.newTransformer();
            transformer.transform(new DOMSource(doc.getDocumentElement()),new StreamResult(new FileOutputStream(RESULT_NAME)));
        } catch (TransformerConfigurationException | FileNotFoundException ex) {
            Logger.getLogger(DOMManipulation.class.getName()).log(Level.SEVERE, "Error saving file.", ex);
        } catch (TransformerException ex) {
            Logger.getLogger(DOMManipulation.class.getName()).log(Level.SEVERE, "Error saving file.", ex);
        }
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        DOMManipulation dom = new DOMManipulation();
        dom.loadDocument();
        dom.calculateTotal();
        dom.calculateAvg();
        dom.saveDocument();
    }

    public int getTotalPrice() {
        int total = 0;
        try {
            
            XPathFactory xpf = XPathFactory.newInstance();
            XPath xPath = xpf.newXPath();
            String result = (String)xPath.evaluate("sum(//price)",doc.getDocumentElement() , XPathConstants.STRING);
            total = Integer.parseInt(result);
            
        } catch (XPathExpressionException ex) {
            Logger.getLogger(DOMManipulation.class.getName()).log(Level.SEVERE, null, ex);
        }finally{
            System.out.println("Total price: " + total);
            return total;
        }
    }

    public void addTotalPrice(int total) {
        Element production = (Element) doc.getElementsByTagName("production").item(0);
        Element totalElement = doc.createElement("total");
        totalElement.setTextContent(total+"");
        production.appendChild(totalElement);
    }

    public double getTotalAmount() {
        double amount = 0.0;
        NodeList totalElements = doc.getElementsByTagName("amount");
        for(int i=0;i<totalElements.getLength();i++)
        {
            Element totalElement = (Element) totalElements.item(i);
            int total = Integer.parseInt(totalElement.getTextContent().trim());
            amount += total;
        }
        return amount;
    }

    public void addAvgPrice(double average) {
        Element production = (Element)doc.getElementsByTagName("production").item(0);
        production.setAttribute("average", average + "");
    }

    
    
}
